import 'package:flutter/foundation.dart';
import 'package:hive_flutter/hive_flutter.dart';

abstract class IStorage {
  // Future close();
  Future<void> openBox(
    String boxName,
  );
  bool isStorageOpen();
  Future<void> putData({required Map<String, dynamic> json});
  Future<void> putDynamicData({required String key, required dynamic value});
  Future<void> putListData({required List dataList});
  Future<void> putString({required String key, required String value});
  Future<void> putBool({required String key, required bool value});

  String? getString({required String key});
  DateTime? getDate({required String key});
  int? getInt({required String key});
  bool getBool({required String key});
  double? getDouble({required String key});
  Map<String, dynamic>? get getData;
  getDynamicData({required String key});
  List? getListData();
  Future<void> deleteData();
  Future<void> deleteString({required String key});
  ValueListenable<Box> listenable({List? keys});
}
